<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_product_typePincode extends JPlugin
{
	function plgJoomsuite_product_typePincode( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField( &$obj, &$params, $type)
	{
		if($type != 'pincode') return;
		$out = '';
		if($params->get('show_pin'));//$obj->show_pin)
		{
			$out .= '<textarea class="inputbox" style="width: 50%;" rows="5" name="pparams['.$obj->id.'][pincodes]">'.(isset($obj->pincodes) ? str_replace("|", "\n", $obj->pincodes) : '').'</textarea>';
		}
		echo $out;

	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'pincode') return;
		if(!$value) return;

		$db = &JFactory::getDBO();
		$value = $db->getEscaped(trim($value));
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$type = $field->type;
		
		if($type != 'pincode') return;
		if(!$field) return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		
		if(!$field) return;
		$db = & JFactory::getDBO();

		if($params->get('show_pin'))
		{
			$val = new JParameter($field->value);
			
			$sql = "SELECT pr.extra
			FROM jos_jc_orders_products pr
			JOIN jos_jc_orders ord ON pr.order_id = ord.id
			JOIN jos_js_res_field_extra ex ON pr.product_id=ex.record_id
			JOIN jos_jc_orders_statuses st ON pr.status_id = st.id
			WHERE pr.product_id = '{$field->record_id}' AND ord.user_id = '".$user."'  AND pr.extra != ''
			AND st.isfinal = '1' AND st.type= 'product'
			GROUP BY pr.id";
			$db->setQuery($sql);
			//echo $db->_sql;
			if($res = $db->loadObject())
			{
				$obj = new JParameter($res->extra);
				$pins = '';
				$list = $obj->get('pincodes');
				settype($list, 'array');
				foreach($list as $pin)
				{
					$pins .= '<li>'.$pin.'</li>';
				}
				$out = JText::_("Purchased PIN codes").": <br><ul>".$pins.'</ul><br>';

			}

			$pin = $val->get('pincodes');
			if($pin) {
				$out .=  JText::_("Purchasing this product you will get").' '.JText::_("a new PIN code");
			}
			if($params->get('show_storage'))
			{
				if(!$pin) {
					$out .= '<b>'.JText::_('There is no pincodes on storage').'</b>';
					return;
				}
				settype($pin, 'array');
				$out .= '<br><span class="small"><b>'.JText::_('Storage on hand').': '.count($pin).' '.JText::_('pincode').'</b></span>';
			}

		}
	}


	function onOrderHistoryPrint($type, $order_id, $product_id, $value, $final_status, $user_id, $params)
	{
		if($type != 'pincode') return;
		if($value == '') return;
		
		$db = & Jfactory::getDBO();
		$document = &JFactory::getDocument();
		
		$document->addScript( JURI::root().'media/mightyextensions/js/felix_js/library.js' );
		$document->addScript( JURI::root().'media/mightyextensions/js/felix_js/pop_up.js' );
		$id = rand(0, 1000);
		$document->addScriptDeclaration("var plg_type_pincode_popUp".$id." = felixPopUp_v2.newPopUp( {pos_mode:'bottom', slide_mode:'vertical', duration:500, duration_close:200, scope_class:'popup_scope'} );");
		
		$out = '';
		$sql = "SELECT extra FROM #__jc_orders_products WHERE order_id= '$order_id' AND product_id='$product_id'";
		$db->setQuery($sql);
		$val = $db->loadResult();
		if($val == '') return;

		$pins = explode("=", $val);
		if(isset($pins[1]) && $pins[1]!='')
		{
			if($final_status)
			{
				$out .= '
				<style>
					.pincodeList { border: 1px solid #333; padding: 5px; background-color: #fff; margin-left: 15px; color: #000; } 
				</style>';
				$out .= '<a href="javascript:void(0);" onClick="plg_type_pincode_popUp'.$id.'.toggle( this )" id="typePincode'.$id.'">'.JText::_('Purchased PIN codes').'</a>';
				$out .= '<div id="typePincode'.$id.'List" class="small pincodeList">';
				$out .= str_replace("|", "<br>", $pins[1]);
				$out .= '</div>';
				$out .= '
				<script type="text/javascript">  
			     	plg_type_pincode_popUp'.$id.'.attachChild( "typePincode'.$id.'", "typePincode'.$id.'List" );
				</script>';
			}
			else
			{
				$out .=  JText::_("Order must be shipped to get PIN codes");
			}
			//	}
			return $out;
		}
	}

	function onAfterSuccessOrder($type, $order_id, $product_id, $field_id, $value, $user_id, $amount)
	{
		if($type != 'pincode') return;
		if($value == '') return;

		$db = & Jfactory::getDBO();

		$value = str_replace(',', '|', $value);
		$value = str_replace(', ', '|', $value);
		$value = str_replace(';', '|', $value);
		$obj = new JParameter($value);
		$pins = $obj->get('pincodes');
		if(!is_array($pins)) settype($pins, 'array');
		for($i = 0; $i < $amount; $i ++)
		{
			if(count($pins) > 0)
			{
				$give = array_shift($pins);

				$obj->set('pincodes', implode("|", $pins));
				$sql = "Update #__js_res_field_extra SET value = '".$obj->toString()."'
				WHERE record_id = '$product_id' AND ref_id = 'pincode' AND field_id = '$field_id'";
				$db = & Jfactory::getDBO();
				$db->setQuery($sql);
				$db->query();
			}
			
			if($give)
			{
				$obj->set('pincodes', $give);

				$sql = "SELECT pr.extra, pr.order_id
				FROM #__jc_orders_products pr
				JOIN #__jc_orders ord ON pr.order_id = ord.id
				WHERE ord.user_id = '$user_id' AND pr.product_id = '$product_id' ORDER BY pr.id";
				$db->setQuery($sql);
				$userpin = '';
				$orders = array();
				$userpin = 'pincodes='.$give;
				if($res = $db->loadObjectList())
				{
					if($res[0]->extra != '' )
					{
						$ext = new JParameter($res[0]->extra);
						$havepin = ( is_array($ext->get('pincodes')) ) ? implode("|",$ext->get('pincodes')) : $ext->get('pincodes');
						$ext->set('pincodes', $havepin."|".$give );
						$userpin = $ext->toString();
					}
					foreach($res as $item)
					{
						$orders[] = $item->order_id;
					}
				}

				if($userpin != '')
				{
					$sql = "UPDATE #__jc_orders_products SET extra = '$userpin'
					WHERE order_id IN (".implode(", ", $orders).") AND product_id = '$product_id'";
					$db->setQuery($sql);
					$db->query();
				}
			}
		}
	}




	function onTypeFormRender()
	{

	}

	function onBeforeCartStore()
	{

	}
}
?>